#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e5;
bool in[maxn], important[maxn];
int n, k, m, lead[maxn], sz[maxn];
long long ans = 1e18;
struct edge
{
    int from, to;
    long long c;
};
vector <edge> v;
vector <int> imp;

bool cmp(edge e1, edge e2)
{
    return (e1.c <= e2.c);
}

int find_leader(int x)
{
    if (x == lead[x]) return x;
    lead[x] = find_leader(lead[x]);
    return lead[x];
}

bool dsu(int x, int y)
{
    int l1 = find_leader(x);
    int l2 = find_leader(y);
    if (l1 == l2)
        return false;

    if (sz[l1] < sz[l2])
    {
        sz[l2] += sz[l1];
        sz[l1] = 0;
        lead[l1] = l2;
    }
    else
    {
        sz[l1] += sz[l2];
        sz[l2] = 0;
        lead[l2] = l1;
    }
    return true;
}

void check()
{
    int i;
    for (i=1; i<=n; ++i)
    {
        lead[i] = i;
        sz[i] = 1;
    }

    int x, y;
    long long sum = 0;
    for (i=0; i<m; ++i)
    {
        x = v[i].from, y = v[i].to;

        if (in[x] == false || in[y] == false)
            continue;

        if (dsu(x, y))
            sum += v[i].c;
    }

    for (i=0; i<k-1; ++i)
    {
        if (find_leader(imp[i]) != find_leader(imp[i+1]))
            return;
    }

    if (sum < ans)
        ans = sum;
}

void solve()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> k >> m ;
    int i, x;
    for (i=1; i<=k; ++i)
    {
        cin >> x ;
        important[x] = true;
        in[x] = true;
        imp.push_back(x);
    }

    int y;
    long long z;
    for (i=1; i<=m; ++i)
    {
        cin >> x >> y >> z ;
        v.push_back({x,y,z});
    }

    sort(v.begin(), v.end(), cmp);
    for (i=1; i<=n; ++i)
    {
        if (important[i])
            continue;
        in[i] = true;
        check();
        in[i] = false;
    }
    cout << ans << '\n' ;
}

int main()
{
    solve();
    return 0;
}