#include <iostream>
#include <algorithm>
#include "saddle.h"
#define MAX_N 505
using namespace std;

const long long fil=1e18+1;
long long table[MAX_N][MAX_N];

pair <int, int> find_saddle_point (int N, int M)
{
    for(int i=0; i<MAX_N; i++)
    {
        for(int j=0; j<MAX_N; j++)
        {
            table[i][j]=fil;
        }
    }
    for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=M; j++)
        {
            if(i!=N || j!=M)
            {
                table[i][j]=value(i, j);
            }
        }
    }
    for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=M; j++)
        {
            if(i!=N || i!=M)
            {
                if(table[i][j]<table[i+1][j] && table[i][j]<table[i-1][j] && table[i][j]<table[i][j+1] && table[i][j]<table[i][j-1])
                {
                    return {i, j};
                }
            }
        }
    }
    return {N, M};
}
